const colorSetting = {
	bg: "black",
	fg: "white",
}

const colorThemes = [
	{
		bg: "white",
		fg: "black",
	},
	{
		bg: "black",
		fg: "white",
	},
	{
		bg: "black",
		fg: "yellow",
	},
	{
		bg: "yellow",
		fg: "black",
	},
	{
		bg: "blue",
		fg: "yellow",
	},
	{
		bg: "yellow",
		fg: "blue",
	}
]

let selectedColor = 0;

export const shortforms = $state({ standardList: "", subjectList: "", cache: new Map() })
export const importState = $state({ data: "", errors: [] })
export const textSettings = $state({ font: "Arial", size: 30, colors: colorSetting, padding: 0, lineheight: 1 })
export const appState = $state({ text: "", menuOpen: false, open: "" })

import { toast } from "svelte-sonner";
import { db } from "../db/main"
import { cacheShortforms } from "../modules/shortforms"

export const initShortformState = async () => {
	const lists = await db.lists.toArray()
	if (shortforms.standardList == "") {
		if (lists.length > 0) {
			console.log("Väljer en av standardlistorna")
			shortforms.standardList = lists[0].id
			toast("Ingen standardlista vald. Väljer " + lists[0].name)
			shortforms.cache = cacheShortforms([shortforms.standardList]);
		}
	}
}

export const selectNextColor = () => {
	selectedColor += 1
	textSettings.colors = colorThemes[(selectedColor % 6)]
}

export const toggleMenuOpen = (force = undefined) => {
	if (force == undefined) {
		appState.menuOpen = !appState.menuOpen
	} else {
		appState.menuOpen = force
	}
}


export const incTextSize = () => {
	console.log(textSettings.size)
	if (textSettings.size < 200) {
		textSettings.size += 5
		return
	}
	if (textSettings.size > 200) {
		textSettings.size = 200
		return
	}
}

export const decTextSize = () => {
	if (textSettings.size > 15) {
		textSettings.size -= 5
		return
	}
	if (textSettings.size <= 15) {
		textSettings.size = 15
		return
	}
}
